const config=new Object();

function clear(){
	let el=config.document.getElementById(config.debugId);
	if (el===null) {
		//alert("Debug section not initialized");
		return;
	}
	config.document.getElementById(config.debugId).value="";
}

function print(msg){
	let el=config.document.getElementById(config.debugId);
	if (el===null) {
		//alert("Debug section not initialized. Message: "+msg);
		return;
	}
	el.value+="\n"+msg;
}

function getCRFref(){
	//'crfRefId'
	return config.document.getElementById(config.crfRefId).innerHTML;
}

function onFailure(errorInfo, options, responseObj){
	
	if (errorInfo && errorInfo.exception)
		alert("Failure: " + errorInfo.exception);
	else
		alert("Failure: " + responseObj.statusText);
}

function generateDebugSection(){
	//let debug=true;
	//if (debug) print("generateDebugSection "+sectionName);

	let formName=config.debugDiv;
	let sectionName="debugSection";
	let sectionTitle="Debug Messages";
	let tb=config.document.createElement('table');
	tb.className='t2';
	let row=tb.insertRow();
	let cell=config.document.createElement('th');
	row.appendChild(cell);	
	cell.setAttribute("colspan","4");
	cell.style.fontSize="20px";
	cell.style.textAlign="center";
	let cellData=config.document.createTextNode(sectionTitle);
	cell.appendChild(cellData);
	cell=row.insertCell();
	let input=config.document.createElement("input");	
	input.type="button";
	input.value="Show";
	input.id="toggle"+sectionName+"VisbilityButton";
	input.onclick=function(){toggleVisibility(sectionName,input.id)};
	cell.appendChild(input);
	config.document.getElementById(formName).appendChild(tb);
	

	let div=config.document.createElement('div');
	div.id=sectionName;
	div.style.display="none";
	config.document.getElementById(formName).appendChild(div);	

	let debugArea=config.document.createElement('textarea');
	debugArea.rows=10;
	debugArea.cols=95;
	debugArea.id=config.debugId;
	div.appendChild(debugArea);



}




function setAdditionalData(additionalData,entry){
	let debug=true;
	if (debug) print("setAdditionalData");
	if (entry["showFlag"]==="NONE") {
		if (debug) print("Returning empty additionalData");
		return additionalData;
	}
	if (entry["showFlag"]==="REVIEW") {
		//abuse additionalData to signal different segment
		if (debug) print("Returning additionalData that signal review form");
		additionalData.isReview=true;
		return additionalData;
	}

	additionalData.showFlag=entry["showFlag"];
	additionalData.showFlagValue=entry["showFlagValue"];
	additionalData.queryName=entry["showQuery"];
	additionalData.filters=new Object();
	additionalData.filters['crfRef']=getCRFref();
	return additionalData;
}

function fullAccessSetup(listName){
	let debug=true;
	if (debug) print("fullAccessSetup");

	let setup=new Object();
	setup.readonlyFlag=function(vName){return false};
	setup.filters=new Object();
	setup.filters['crfRef']=getCRFref();
	setup.getInputId=function(vName){return listName+"_"+vName;}
	setup.addApply="Save";
	return setup;

}

function readonlySetup(){
	let debug=true;
	if (debug) print("readonlySetup");

	let setup=new Object();
	setup.readonlyFlag=function(vName){return true};
	setup.filters=new Object();
	setup.filters['crfRef']=getCRFref();
	setup.getInputId=function(vName){return vName;}
	return setup;
}

function afterFormConfig(formConfig,data){

	let debug=true;
	if (debug) print("afterFormConfig ["+data.rows.length+"]");
	formConfig.formSetup=data;

	//get list of queries
	let fields=formConfig.formSetup.metaData.fields;

	if (debug) print("generateForm: fields: "+fields);
	let field="NONE";
	//if (debug) printTableSetup(config,data);
	for (f in fields){
		if (fields[f]['name']!='queryName') continue;
		field=fields[f];
		break;
	}
	if (debug) print("generateForm: field: "+field);
	let lookup=field.lookup;
	if (debug) print("generateForm: lookup: "+lookup);
	let qconfig=new Object();
	qconfig.containerPath=config.containerPath;
	qconfig.schemaName=lookup.schemaName;
	qconfig.queryName=lookup.queryName;
		
	//qconfig.filterArray=[LABKEY.Filter.create(lookup.keyColumn,entry['queryName'])];
	qconfig.filterArray=[];
	qconfig.success=function(data){afterFormSetupLookup(formConfig,data)};
	LABKEY.Query.selectRows(qconfig);
}

function afterFormSetupLookup(formConfig,data){
	//walk through the list of datasets/list and generate tables for each list
	let debug=true;

	formConfig.formSetupLookup=data;

	let rows=formConfig.formSetup.rows;
	//extract list of forms from formConfig
	for (let i=0;i<rows.length;i++){

		//each from has multiple lists associated with it
		if (debug) print("generateForm ["+i+"/"+rows.length+"]");

		let entry=rows[i];
		//this is actually a pointer into another list (==lookup)
		//another selectRows is needed to actually get the name for the queryName
		
		//id : entry[queryName]
		//name: dentry[queryName]
	
		let queryId=entry['queryName'];

		//walk over keys to get the right lookup entry
		let lookupRows=formConfig.formSetupLookup.rows;
		let dentry=undefined;
		for (let j=0;j<lookupRows.length;j++){
			
			if (lookupRows[j].Key!=queryId)
				continue;
			dentry=lookupRows[j];
			break;
		}
		if (dentry===undefined){
			print("generateForm ["+i+"] no list found");
			return;
		}
		if (debug)
			for (f in dentry) 
				print("generateFormLookup field: "+f+" value: "+dentry[f]);
	
		let queryName=dentry["queryName"];

		if (debug) print("generateFormLookup: ID: "+queryId+" name: "+queryName);
	
		//update fields for review
		while (1){
			//queryName already recorded
			if (queryName in config.fields) break;
			//reviews dont go into fields
			if (entry['showFlag']=='REVIEW') break;
				
			config.fields[queryName]=new Object();
			break;
		}
		
		while(1){
			if (queryId in config.queryMap) break;
			//reviews dont go into fields
			if (entry['showFlag']=='REVIEW') break;

			config.queryMap[queryId]=queryName;
			break;
		}
	
		if (queryName in config.fields){
			let field=config.fields[queryName];

			field.title=entry["title"];
			field.queryId=queryId;
		}

		if (debug) print("entry[showFlag]: "+entry["showFlag"]);

		let additionalData=new Object();
		setAdditionalData(additionalData,entry);
		//section fits one dataset/list
		generateSection(formConfig,queryName,entry["title"],queryName, additionalData);
	}

}

function generateSection(formConfig, sectionName, sectionTitle, listName, additionalData){


	let formName=config.masterForm;//this is HTML designator of area on page
	let debug=true;
	if (debug) print("generateSection "+sectionName);
	let tb=config.document.createElement('table');
	tb.className='t2';
	let row=tb.insertRow();
	let cell=config.document.createElement('th');
	row.appendChild(cell);	
	cell.setAttribute("colspan","4");
	cell.style.fontSize="20px";
	cell.style.textAlign="center";
	let cellData=config.document.createTextNode(sectionTitle);
	cell.appendChild(cellData);
	cell=row.insertCell();
	let input=config.document.createElement("input");	
	input.type="button";
	input.value="Show";
	input.id="toggle"+sectionName+"VisbilityButton";
	input.onclick=function(){toggleVisibility(sectionName,input.id)};
	cell.appendChild(input);
	config.document.getElementById(formName).appendChild(tb);

	let div=config.document.createElement('div');
	div.id=sectionName;
	div.style.display="none";
	config.document.getElementById(formName).appendChild(div);	

	let divTable=config.document.createElement('div');
	divTable.id=sectionName+"Table";
	div.appendChild(divTable);
	
	if ("showFlag" in additionalData) {

		additionalData.divName=sectionName+"SubDiv";
		additionalData.divQueryName=sectionName+"SubDivList";

		let div1=config.document.createElement('div');
		div1.id=additionalData.divName;
		div1.style.display="none";
		div.appendChild(div1);
	
		let div2=config.document.createElement('div');
		div2.id=additionalData.divQueryName;
		div1.appendChild(div2);

	}
	if (debug) print("generate master table");

		
	let setup=fullAccessSetup(listName);
	if (formConfig.formStatus=="Submitted")
		setup=readonlySetup();
	if (formConfig.formStatus=="Approved")
		setup=readonlySetup();
	
	if ("isReview" in additionalData){
		generateReviewSection(listName,div.id,generateReviewSectionCB);
		return;	
	}
	//master table is unique per visit

	
	setup.unique=true;
	generateTable(formConfig,listName,divTable.id,true,additionalData,setup);
	
	if (debug) print("generate master table: done");

	let generateSubTable=true;
	if (formConfig.formStatus=="Submitted")
		generateSubTable=false;
	if (formConfig.formStatus=="Approved")
		generateSubTable=false;
	
	if (! ("showFlag" in additionalData) ) generateSubTable=false;
	
	if (generateSubTable){
		let qName=additionalData.queryName;
		let dName=additionalData.divName;
		

		let setup=fullAccessSetup(qName);
		//if (readonly) setup=readonlySetup(config);
		generateTable(formConfig,qName,dName,false,additionalData,setup);
	}

	print("generate review");

	let divReviewList=config.document.createElement('div');
	divReviewList.id=sectionName+"ReviewList";
	div.appendChild(divReviewList);
	
	let divReview=config.document.createElement('div');
	divReview.id=sectionName+"Review";
	div.appendChild(divReview);


	//assume we already have listId (content of config.setupQueryName is listId)
	//we need listName also
	//qconfig.queryName=config.setupQueryName;
	generateReview(formConfig,divReview.id,divReviewList.id,listName);
}


function parseResponseXML(){
	//print(config.config,'Status:' +this.status);
	print('Status:'+this.status);
	if (this.status!=200) return;
	config.loadFileConfig.json=JSON.parse(this.responseText);
	config.loadFileConfig.cb();
}

function loadFile(){
	print('YY: '+config.loadFileConfig.url);

	let connRequest=new XMLHttpRequest();
	connRequest.addEventListener("loadend",parseResponseXML);
		//function(e){parseResponseXML(e,config);});
	connRequest.open("GET", config.loadFileConfig.url);
	connRequest.send();
}


function getBasePath(){
	let server=LABKEY.ActionURL.getBaseURL();
	let basePath=server+"_webdav";
	basePath+=LABKEY.ActionURL.getContainer();
	return basePath;
}


function generateReviewSection(listName,id,callback){
	//callback should be generateReviewSectionCB and it takes no arguments
	print("generateReviewSection");
	//need base path


	config.loadFileConfig=new Object();
	
	
	config.loadFileConfig.cb=callback;
	config.loadFileConfig.id=id;
	config.loadFileConfig.url=getBasePath()+'/@files/reportSetup/'+listName+'.json';
	loadFile();
	//load file and continue in the next function
}


function generateErrorMessage(id,listName,msg){
	print('generateErrorMessage:');
	let eid=listName+"_errorMsg";
	let el=config.document.getElementById(eid);
	if (el===null){
		el=config.document.createElement("p");
		config.document.getElementById(id).appendChild(el);
	}
	el.innerHTML=msg;
}

function clearErrorMessage(listName){
	let eid=listName+"_errorMsg";
	let el=config.document.getElementById(eid);
	if (el===null) return;
	el.remove();
}

function getParticipantCode(pid){
	let selectRows=new Object();
	selectRows.schemaName='lists';
	selectRows.queryName='PET';
	pid.afterId=setParticipantCode;
	selectRows.success=function(data){afterRegistration(pid,data);}
	selectRows.filterArray=[LABKEY.Filter.create("crfRef",getCRFref())];
	LABKEY.Query.selectRows(selectRows);
}

function visitCodeFromVisitId(visitId){
	if (visitId<0) return "NONE";
	let project=LABKEY.ActionURL.getContainer();
	print('visitCodeFromVisitId: '+project.search('retro'));
	if (project.search('retro')>-1)
		visitId-=1;
	return 'VISIT_'+visitId.toString();
}

function replaceSlash(x){
	return x.replace(/\//,'_');
}

function setParticipantCode(pid){
	let rows=pid.registration.rows;
	if (rows.length==1){
		print('setParticipantCode: '+rows[0].participantCode+'/'+rows[0].visitId);
		let visitCode=visitCodeFromVisitId(rows[0].visitId);
		print('setParticipantCode: '+pid.participantId+'/'+visitCode);
		pid.participantCode=replaceSlash(pid.participantId);
		pid.visitCode=visitCode;
	}
	generateReviewSection2(pid);
}


function generateReviewSectionCB(){

	let listName=config.loadFileConfig.listName;
	let id=config.loadFileConfig.id;

	clearErrorMessage(listName);

	let pid=new Object();
	pid.participantCode="NONE";
	pid.visitCode="NONE";
	getParticipantCode(pid);
	print('Get participant code sent');
	//involves database search, continue after callback
}

function getValueFromElement(id,defaultValue){
	let e=config.document.getElementById(id);
	if (e!=null){
		defaultValue=e.innerHTML;
	}
	return defaultValue;
}

function pickParticipantCodeFromPage(){
	let pid=new Object();
	pid.participantCode=getValueFromElement("participantCode","NIX-LJU-D2002-IRAE-A000");
	pid.visitCode=getValueFromElement("visitCode","VISIT_1");
	generateReviewSection2(pid);
}


function patternReplace(src,replacements,values){

	for (rep in replacements){
		let txt1=src.replace(new RegExp(rep),values[replacements[rep]]);
		src=txt1;
	}
	return src;

}

function plotImage(row,rowVariable,obj,pid){
	let nim=obj.values.length;
	let baseDir=patternReplace(obj.imageDir,obj.replacements,pid);
	print('Base dir: '+pid.basePath);
	for (let im=0;im<nim;im++){
		pid[obj.variable]=obj.values[im];
		let img=config.document.createElement('img');

		let imgSrc=patternReplace(obj.file,obj.replacements,pid);
		print('Image: '+imgSrc);
		let imagePath=pid.basePath+'/'+baseDir+'/'+imgSrc;
			
		img.src=imagePath;
		img.width="300";

		let cell=row.insertCell();
		cell.id=pid[obj.variable]+"_"+rowVariable+pid[rowVariable];
		cell.appendChild(img);
	}
}

function showReport(row,rowVariable,obj,pid){
	let nr=obj.values.length;
	for (let ir=0;ir<nr;ir++){

		let cell=row.insertCell();
		cell.id=obj.values[ir]+"_"+rowVariable+pid[rowVariable];
		cell.width="300px";
		let reportConfig=new Object();
		reportConfig.partName="Report";
		reportConfig.renderTo=cell.id;
		//reportConfig.showFrame=false;
		//reportConfig.width="300";
		reportConfig.frame="none";
		reportConfig.partConfig=new Object();
		reportConfig.partConfig.width="300";
		reportConfig.partConfig.title="R Report";
		reportConfig.partConfig.reportName=obj.values[ir];
		for (f in obj.parameters){
			reportConfig.partConfig[f]=pid[f];
		}
		reportConfig.partConfig.showSection="myscatterplot";
		let reportWebPartRenderer = new LABKEY.WebPart(reportConfig);
		print('Render to: '+reportConfig.renderTo);
		reportWebPartRenderer.render();
	}
}


function showProbability(row,rowSetup,j,obj,pid){
	print('showProbability: '+rowSetup);
	let np=obj.values.length;

	let probDensity=new Object();
	probDensity.mean=rowSetup.mean[j];
	probDensity.sigma=rowSetup.sigma[j];

	print('showProbability: mean '+probDensity.mean+' sigma '+probDensity.sigma);
	for (let ip=0;ip<np;ip++){


		let cell=row.insertCell();
		probDensity.func=obj.values[ip];
		probDensity.organCode=pid.organCode;
		pid[obj.variable]=rowSetup[obj.variable][j];
		probDensity.percentile=pid.percentile;
		let selectRows=new Object();
		selectRows.queryName=obj.queryName;
		selectRows.schemaName="study";
		selectRows.filterArray=[];
		for (let f in obj.filters){
			selectRows.filterArray.push(LABKEY.Filter.create(f,pid[obj.filters[f]]));
			print('Filter ['+f+']: '+pid[obj.filters[f]]);
		}
		selectRows.success=function(data){drawProbability(data,cell,obj,pid,probDensity);}
		LABKEY.Query.selectRows(selectRows);

	}
}

function erf(x){
	let fx=[0,0.02,0.04,0.06,0.08,0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,
		1,1.1,1.2,1.3,1.4,1.5,1.6,1.7,1.8,1.9,2,
		2.1,2.2,2.3,2.4,2.5,3,3.5];
	let fy=[0,0.222702589,0.328626759,0.428392355,0.520499878,0.603856091,0.677801194,0.742100965,0.796908212,
	 	0.842700793,0.880205070,0.910313978,0.934007945,0.952285120,0.966105146,0.976348383,
		0.983790459,0.989090502,0.992790429,0.995322265,
		0.997020533,0.998137154,0.998856823,0.999311486,0.999593048,0.999977910,0.999999257];
	let n=32;
	let i0=n-1;

	for (let i=1;i<n;i++){
		if (Math.abs(x)>fx[i]) continue;
		i0=i-1;
		break;
	}
	let fval=1;
	if (i0<n-1){
		//interpolate
		let y1=fy[i0+1];
		let y0=fy[i0];
		let x1=fx[i0+1];
		let x0=fx[i0];
		fval=y0+(y1-y0)/(x1-x0)*(Math.abs(x)-x0);
	}
	print('Erf: '+fval);
	if (x<0) return -fval;
	return fval;
}



function drawProbability(data,cell,obj,pid,probDensity){
	print('drawProbability');
	if (data.rows.length!=1){
		print("drawProbability row length mismatch: "+data.rows.length);
		return;
	}
	//possible mismatch; I assume the dataset will have a field called value
	let val=data.rows[0].value;

	let prob=0;
	let fz=-100;

	if (probDensity.func=="gaus"){
		fz=(val-probDensity.mean)/probDensity.sigma/Math.sqrt(2);
		prob=0.5+0.5*erf(fz);
	}
	let color="red";
	let fzx=fz*Math.sqrt(2);
	print('drawProbability '+fzx);

	for (let i=1;i<obj.intervals.n;i++){
		if (fzx>obj.intervals.zlimits[i]) continue;
		color=obj.intervals.colors[i-1];
		break;
	}

	let fbox=config.document.createElement("div");
	fbox.style.backgroundColor=color;
	fbox.style.width="180px";
	fbox.style.height="180px";
	

	print('organCode '+probDensity.organCode);
	let organName="Lung";

	if (probDensity.organCode==4){
		organName="Thyroid";
	}
	if (probDensity.organCode==5){
		organName="Bowel";
	}

	let fp4=document.createElement("p");
	fp4.classList.add("center");
	fp4.style.textAlign="center";
	fp4.innerHTML=organName;
	fbox.appendChild(fp4);
	
	let fp=document.createElement("p");
	//fp.innerHTML=prob.toPrecision(3);
	fp.innerHTML=val.toPrecision(3);
	fp.style.fontSize="25px";
	fp.style.textAlign="center";
	fbox.appendChild(fp);

	let fp1=document.createElement("p");
	fp1.classList.add("center");
	fp1.style.textAlign="center";
	//fp1.innerHTML="IRAEMM-probability";
	fp1.innerHTML="SUV("+probDensity.percentile+"%)";
	fbox.appendChild(fp1);

	let fp2=document.createElement("p");
	fp2.innerHTML=fzx.toPrecision(3);
	fp2.style.fontSize="25px";
	fp2.style.textAlign="center";
	fbox.appendChild(fp2);

	let fp3=document.createElement("p");
	fp3.classList.add("center");
	fp3.style.textAlign="center";
	fp3.innerHTML="z-value";
	fbox.appendChild(fp3);


	cell.appendChild(fbox);
}

function generateReviewSection2(pid){ 
	
	let listName=config.loadFileConfig.listName;
	let id=config.loadFileConfig.id;
	
	print('generateReviewSection2: '+pid.participantCode+'/'+pid.visitCode);
	if (pid.participantCode=="NONE" || pid.visitCode=="NONE"){
		generateErrorMessage(id,listName,"ParticipantId/visitId not set");
		return;
	}
	

	print('JSON: '+config.loadFileConfig.json);

	let json=config.loadFileConfig.json;
	let nrows=json.rows.values.length;
	let ncol=json.columns.length;

	pid.basePath=getBasePath()+"/@files";
	
	
	let el=config.document.getElementById(id);
	let table=config.document.createElement('table');
	table.style.tableLayout="fixed";
	table.style.columnWidth="300px";
	el.appendChild(table);
	
	for (let i=0;i<nrows;i++){
		pid[json.rows.variable]=json.rows.values[i];
		//let organ=organs[i];
		let row=table.insertRow();

		for (let j=0;j<ncol;j++){
			let obj=json.columns[j];
			if (obj.display=="image") 
				plotImage(row,json.rows.variable,obj,pid);
			if (obj.display=="report") 
				showReport(row,json.rows.variable,obj,pid);
			if (obj.display=="probability"){ 
				showProbability(row,json.rows,i,obj,pid);
			}


		}
		

	}
}

function generateReview(formConfig,divReviewId,divReviewListId, listName){
	let listId=config.fields[listName].queryId;

	let debug=true;
	if (debug) print("Generate review for: "+listId);
	
	let reviewSetup=new Object();
	reviewSetup.readonlyFlag=function(vName){
		if (vName=="queryName") return true; 
		if (vName=="queryname") return true; 
		if (vName=="ModifiedBy") return true;
		return false;};
	reviewSetup.addApply="Add Review";

	let generateTableFlag=true;
	if (formConfig.formStatus == "Approved" ){
		delete reviewSetup.addApply;
		reviewSetup.readonlyFlag=function(vName){return false;}
		generateTableFlag=false;
	}
	
	reviewSetup.filters=new Object();
	reviewSetup.filters["crfRef"]=getCRFref();
	
 	reviewSetup.filters["queryName"]=listId;//entry in reviewComments list is queryname, all in small caps
	//needs listName, in argument
	
	reviewSetup.getInputId=function(vName){return listName+"_add"+vName};
	reviewSetup.divReviewListId=divReviewListId;
		

	if (debug) {
		let msg="Review: divId: "+divReviewId;
		msg+=" inputId: "+reviewSetup.getInputId;
		print(msg);
	}
	updateListDisplay(divReviewListId,"reviewComments",reviewSetup.filters,true);
	
	if (! generateTableFlag) return;

	
	generateTable(formConfig,"reviewComments",divReviewId,false,new Object(),reviewSetup);
}	

function setListVisibility(setup,additionalData,readonlyFlag){
	let debug=true;
	if (debug){
		print("Set list visibility ");
		for (f in additionalData){
			print("AdditionalData["+f+"]: "+additionalData[f]);
		}
	}
	let x = config.document.getElementById(additionalData.divName);
	if (debug) print("\n Div: "+x);
	x.style.display="none";
	let eId=setup.getInputId(additionalData.showFlag);
	let e = config.document.getElementById(eId);
	
	let sText;
	if (readonlyFlag) sText=e.innerHTML;
	else sText=e.options[e.selectedIndex].text;
	
	if (debug) print("\n Selected option text: "+sText);

	if (sText == additionalData.showFlagValue){
		let filters=new Object();
		if ("filters" in additionalData) filters=additionalData.filters;
		x.style.display = "block";
		updateListDisplay(additionalData.divQueryName,
			additionalData.queryName,filters,readonlyFlag);
	}
}

function updateListDisplay(divName,queryName,filters,readonlyFlag){
	let debug=true;

	if (debug) print("UpdateListDisplay: Query - "+queryName+" div - "+divName);

	if (divName=="NONE") return;

	let crfRef=getCRFref();
	let div=config.document.getElementById(divName);

	if (debug)
		print("Enabling display to queryName: "+queryName);
	
	var qconfig=new Object();
	qconfig.renderTo=divName;
	qconfig.containerPath=config.containerPath;
	qconfig.schemaName='lists'; 
	qconfig.queryName=queryName;
	qconfig.buttonBarPosition='top';
	qconfig.filters=[];
	for (f in filters){
		qconfig.filters.push(LABKEY.Filter.create(f, filters[f]));
	}
	qconfig.success=updateSuccess;
	qconfig.failure=updateFailure;
	//show only print button
	if (readonlyFlag){
		qconfig.buttonBar=new Object();
		qconfig.buttonBar.items=["print"];
	}

	LABKEY.QueryWebPart(qconfig);
	
}

function updateSuccess(data){
	print("Update success");
}

function updateFailure(data){
	print("Update failed");
}

function toggleVisibility(divName,buttonName){

	let x = config.document.getElementById(divName);
	if (x.style.display === "none") {
    		x.style.display = "block";
		config.document.getElementById(buttonName).value="Hide";

  	} else {
    		x.style.display = "none";
		config.document.getElementById(buttonName).value="Show";

  	}
}

function generateButtonBU(divName,title,buttonName,callback,callbackParameters){
	let debug=true;
	if (debug) print("generateButtonBU");
	
	let tb=config.document.createElement('table');
	tb.className="t2";
	
	let r1=tb.insertRow();
	th=config.document.createElement('th');
	r1.appendChild(th);
	th.innerHTML=title;
	//*!*
	let c2=r1.insertCell();
	let i1=config.document.createElement("input");	
	i1.type="button";
	i1.value=buttonName;
	i1.style.fontSize="20px";
	i1.onclick=function(){callback(callbackParameters);}
	c2.appendChild(i1);	

	let c1=r1.insertCell();
	c1.setAttribute("colspan","1");
	c1.id=callbackParameters.submitReportId;

	let el=config.document.getElementById(divName);
	if (debug) print("generateButton: element["+divName+"]: "+el);
	
	
	el.appendChild(tb);
	
	
}

function generateButton(divName,title,buttonName,callback){
	let debug=true;
	if (debug) print("generateButtonX");
	
	let tb=config.document.createElement('table');
	tb.className="t2";
	
	let r1=tb.insertRow();
	th=config.document.createElement('th');
	r1.appendChild(th);
	th.innerHTML=title;
	//*!*
	let c2=r1.insertCell();
	let i1=config.document.createElement("input");	
	i1.type="button";
	i1.value=buttonName;
	i1.style.fontSize="20px";
	i1.onclick=callback;
	c2.appendChild(i1);	

	let c1=r1.insertCell();
	c1.setAttribute("colspan","1");
	c1.id=config.submitReportId;

	let el=config.document.getElementById(divName);
	if (debug) print("generateButton: element["+divName+"]: "+el);
	
	
	el.appendChild(tb);
	
	
}



function generateTable(formConfig,listName,divName,unique,additionalData,setup){

	let debug=true;
	
	if (debug) print("generateTable: "+listName);
	//these objects will contain respective data for the entry

	//add temp variables
	//this will capture the state of the data prior to updating
	let qconfig=new Object();
	qconfig.containerPath=config.containerPath;
	qconfig.schemaName='lists';
	qconfig.queryName=listName;
	//apply filters on data to get right entries
	qconfig.filterArray=[];
	for (f in setup.filters){
		qconfig.filterArray.push(LABKEY.Filter.create(f,setup.filters[f]));
	}
	qconfig.success=function(data){populateTable(formConfig, data,divName,unique,additionalData,setup)};
	LABKEY.Query.selectRows(qconfig);
}

function printTableSetup(data){
	let obj=data.metaData.fields;
	for (f in obj){	
		print("Data["+f+"]: "+obj[f]);
		for (g in obj[f]){
			print("Data.metaData.fields["+f+"]["+g+"]: "+obj[f][g]);
		}
		if ("lookup" in obj[f]){
			for (h in obj[f]["lookup"]){
				print("Lookup["+h+"]: "+obj[f]["lookup"][h]);
			}
		}
	}
}


function populateTable(formConfig, data,divName,unique,additionalData,setup){
	//generate and populate table with the first suitable entry
	let debug=true;
	//avoid resetting of values
	if (!(data.queryName in formConfig.dataFields))
		formConfig.dataFields[data.queryName]=data.metaData.fields;


	if (debug){
		print("populateTable Query: "+data.queryName+" divName: "+divName+" setup: "+setup);


		if (0)  printTableSetup(data);
	}
	
	let crfRef=getCRFref();
	let entry=new Object();

	if (debug)
		print("Data: nrows "+data.rows.length);
	
	//copy values from queryName to formConfig.entries
	if (data.rows.length > 0) formConfig.entries[data.queryName]=data.rows[0];
	
	//this is the current data snapshot
	if (data.queryName in formConfig.entries)
		entry=formConfig.entries[data.queryName];
	
	
	let tb=config.document.createElement('table');
	tb.className="t2";
	config.document.getElementById(divName).appendChild(tb);

	//this are the fields (probably constant)
	let fields=formConfig.dataFields[data.queryName];
	for (f in fields){
		let field=fields[f];
		if (field.hidden) continue;
		
		let vName=field.name;
		
		if (debug) print("Field ["+vName+"]");
		if (vName=="crfRef") continue;		

		let vType=field.type;
		if (debug) print("Field ["+vName+"/"+vType+"]");
		let row=tb.insertRow();
		let cell=config.document.createElement('th');
		row.appendChild(cell);
		let text = config.document.createTextNode(fields[f].shortCaption);
		cell.appendChild(text);
		cell=row.insertCell();
		
		let varValue="UNDEF";
		if (vName in setup.filters) varValue=setup.filters[vName];
		if (vName in entry) varValue=entry[vName];
		if (vType=="date"){
			if (varValue==="UNDEF") varValue=new Date();
			else varValue=new Date(varValue);
		}
		if (debug) print("value: "+varValue);		
		let input;
		if (setup.readonlyFlag(vName)){
			input=config.document.createTextNode(varValue);
			cell.id=setup.getInputId(vName);
		}
		else{
			cell.colSpan="3";

			let cellClass="input";
			let cellType="text";
			if ("lookup" in field){
				input = config.document.createElement("select");
			}
			if (vType=="date"){ 
				input = config.document.createElement("input");
				input.type="date";
			}
			if (vType=="string" && !("lookup" in field)){
				if(vName.search("reviewComment")>-1){
					input = config.document.createElement("textarea");
					input.cols="65";
					input.rows="5";
				}
				else{
					input = config.document.createElement("input");
					input.type="text";
				}
			}
			if (vType=="float"){
				input = config.document.createElement("input");
				input.type="text";
			}	
			if (vType=="boolean"){
				input = config.document.createElement("input");
				input.type="checkbox";
				print("Creating checkbox");
			}

			input.id=setup.getInputId(vName);
			if (varValue != "UNDEF"){
				if (vType=="string") input.value=varValue;
				if (vType=="float")  input.value=varValue;
				if (vType=="date") input.valueAsDate=varValue;
				if (vType=="boolean") input.checked=varValue;
			}
		}

	
		cell.appendChild(input);
		
		if ("lookup" in field){
			let lookup=field["lookup"];
			let qconfig=new Object();
			if (debug) print("populateTable lookup: Query: "+lookup.queryName);
			qconfig.containerPath=config.containerPath;
			qconfig.schemaName=lookup.schemaName;
			qconfig.queryName=lookup.queryName;
			let parameters= new Object();
			parameters.elementId=setup.getInputId(vName);
			parameters.keyColumn=lookup.keyColumn;
			parameters.displayColumn=lookup.displayColumn;
			
			if (vName in setup.filters) parameters.selectedKey=setup.filters[vName];
			if (vName in entry) parameters.selectedKey=entry[vName];
			
			if ("showFlag" in additionalData) parameters.additionalData=additionalData;
			if (debug) print("Populate select for "+parameters.elementId);
			qconfig.success=function(data){
				populateSelect(data,parameters,setup,setup.readonlyFlag(vName))
			};
			LABKEY.Query.selectRows(qconfig);
		}
		
	}
	//add comment field	
	if (!("addApply" in setup)) {
		print("populateTable: done");
		return;
	}
	
	let row=tb.insertRow();

	let th=config.document.createElement('th');
	row.appendChild(th);
	th.innerHTML=setup.addApply; 
	let cell=row.insertCell();
	//cell.setAttribute("colspan","2");
	let input=config.document.createElement("input");	
	input.type="button";
	input.value=setup.addApply;
	cell.appendChild(input);	
	let cell1=row.insertCell();
	cell1.setAttribute("colspan","2");
	cell1.id=setup.getInputId("rerviewLastSave");
	cell1.innerHTML="No recent update";
	input.onclick=function(){saveReview(data.queryName,cell1.id,setup)};
}	
	
function populateSelect(data,parameters,setup,readonlyFlag){
	let debug=true;
	if (debug)
		print("populateSelect on "+data.queryName);
	let elementId=parameters.elementId;
	let keyColumn=parameters.keyColumn;
	let displayColumn=parameters.displayColumn;
	if (debug){
		print("Query: "+data.queryName);
		print("ElementId: "+elementId);
		print("keyColumn: "+keyColumn);
		print("displayColumn: "+displayColumn);
		print("No of options: " +data.rows.length);
	
		if ("selectedKey" in parameters){
			print("SelectedKey: "+parameters["selectedKey"]);
		}
	}
	let el = config.document.getElementById(elementId);
	
	if (debug)
		print("Element: "+el);
   	
	if (!readonlyFlag){
		//clear options
		for(i = el.options.length; i >= 0; i--) {
			el.remove(i);
   		}
	
		let opt = config.document.createElement("option");
		opt.text = "<Select>";
		opt.value = -1;
		el.options[0] = opt;
		if (debug) print( "Adding <Select>");

	}

	for (let i = 0; i < data.rows.length; i++) {
		let displayText = data.rows[i][displayColumn];
		let keyValue = data.rows[i][keyColumn];

		if (!readonlyFlag){
			let opt = config.document.createElement("option");

			opt.text = displayText;
			opt.value = keyValue;
			el.options[el.options.length] = opt;
		
		}
		if (debug) print("Adding: "+keyValue+" : "+displayText);
		
		let t1=checkVariable(el,keyValue,displayText,parameters,"selectedKey",readonlyFlag);
		if (t1) setup.keyValue=keyValue;

		
	}
	
	if (!("additionalData" in parameters)) return;

	if (debug) print("\n Parsing additional data ");

	let additionalData=parameters["additionalData"];	

	let expId=setup.getInputId(additionalData.showFlag);
	if (expId!=elementId) {
		print("Element mismatch: got :"+expId+"/"+elementId);
		return;
	}

	if (debug)
		print("Setting onChange to "+el.id);
	
	el.onchange=function(){setListVisibility(setup,additionalData,readonlyFlag)};
	setListVisibility(setup,additionalData,readonlyFlag);

}	

function checkVariable(el,varValue,displayText, parameters,varName,readonlyFlag){
	let debug=true;
	if (!varName in parameters) return false;
	if (debug) print("Comparing: " + varValue  + "/" + parameters[varName]);
			
        if (varValue==parameters[varName]){
		if (readonlyFlag) el.innerHTML=displayText;
		else {
			el.selectedIndex=el.options.length-1;
			if (debug) print("Equal; "+el.selectedIndex);
		}
		return true;
	}
	return false;
	
}

function saveReview(queryName,elementId,setup){
	let debug=true;
	if (debug) print("saveReview: elementId "+elementId+" queryName "+queryName);
	let qconfig=new Object();
	qconfig.containerPath=config.containerPath;
	qconfig.schemaName='lists';//could be made more generic
	qconfig.queryName=queryName;
	if ("unique" in setup){
		qconfig.filterArray=[LABKEY.Filter.create("crfRef",getCRFref())];

	}
	qconfig.success=function(data){saveReviewToList(data,elementId,setup);}
	//to guess the fields, one must do selectRows first?
	LABKEY.Query.selectRows(qconfig);
}

function saveReviewToList(data,elementId,setup){
	let debug=true;
	if (debug) {
		let msg="saveReviewToList: "+" elementId "+elementId;
		msg+=" nrows "+data.rows.length;
		print(msg);
	}
	let useInsert=false;
	if (!("unique" in setup)) useInsert=true;
	if (data.rows.length==0) useInsert=true;
	let entry=new Object();
	
	if (!useInsert){
		entry=data.rows[0];
 	}
	entry.crfRef=getCRFref();

	if (debug) print("Set crfRef="+entry.crfRef);

	if ("queryName" in setup.filters) {
		entry.queryName=setup.filters["queryName"];
		if (debug) print("Setting queryName: "+entry.queryName);
	}
	if ("queryname" in setup.filters) {
		entry.queryname=setup.filters["queryname"];
		if (debug) print("Setting queryname: "+entry.queryname);
	}
	let fields=data.metaData.fields;
	for (f in fields){

		let field=fields[f];
		if (debug) print("saveReview field: "+field.name);
		if (field.hidden) continue;
		
		let vName=fields[f].name;

		if (vName=="crfRef") continue;
		if (vName=="queryName") continue;
		if (vName=="queryname") continue;
		
		let eId=setup.getInputId(vName);
		
		let el=config.document.getElementById(eId);
				
		if (!el) {
			if (debug) print("saveReview element: "+eId+" not found");
			continue;
		}
		if (debug) print("saveReview element: "+eId);
		
		let vType=fields[f].type;

		if (debug) print("vType: "+vType);

		if ("lookup" in fields[f]){
			if (el.nodeName==="SELECT"){
				entry[vName]=el.options[el.selectedIndex].value;
			}
			if (el.nodeName==="TD"){
				entry[vName]=el.innerHTML;	
			}

			print("Setting lookup to "+entry[vName]);
			continue;
		}
		if (vType=="date"){
			var date=el.valueAsDate;
			if (date==="null") continue;
			date.setUTCHours(12);
			entry[vName]=date.toString();
			print("Setting date to "+entry[vName]);
		}	
		if (vType=="string"){
			entry[vName]=el.value;
		}	
		if (vType=="float"){
			entry[vName]=el.value;
		}	
		if (vType=="boolean"){
			entry[vName]=el.checked;
		}


	}
	
	let qconfig=new Object();
	qconfig.rows=[entry];
	qconfig.containerPath=config.containerPath;
	qconfig.schemaName=data.schemaName;
	qconfig.queryName=data.queryName;

	//only update comments
	print("modifyRows: useInsert "+useInsert);
	qconfig.success=function(data){updateLastSavedFlag(data,setup,elementId)};
	if (!useInsert){
		LABKEY.Query.updateRows(qconfig);
	}
	else{
		LABKEY.Query.insertRows(qconfig);
	}
}

function updateLastSavedFlag(data,setup,elementId){
	let debug=true;
	if (debug) print("Update last saved flag to "+elementId);
	let el=config.document.getElementById(elementId);
	let dt=new Date();
	el.innerHTML="Last saved "+dt.toString();
	if (data.queryName=="reviewComments"){
		updateListDisplay(setup.divReviewListId,"reviewComments",setup.filters,true);
	}	
}

//******************************************upload to database *********************


function onDatabaseUpload(){
	print("Database upload");
	configUpload=new Object();
	//figure out the participantId
	
	let qconfig=new Object();

	qconfig.schemaName="lists";
	qconfig.queryName="Forms";
	qconfig.filterArray=[LABKEY.Filter.create('Key',config.formId)];
	
	//qconfig.filterArray=[LABKEY.Filter.create('formStatus',1)]
	qconfig.success=function(data){afterForms(configUpload,data)};
	LABKEY.Query.selectRows(qconfig);

}

function afterForms(configUpload,data){	
	let formEntry=data.rows[0];
	configUpload.registrationQueryId=formEntry["masterQuery"];
	configUpload.afterId=afterParticipantId;
	let qconfig=new Object();
	qconfig.queryName=config.queryMap[configUpload.registrationQueryId];
	//queryMap holds mapping for queries in visit; 
	//masterQuery should be one of them, so this is safe.
	qconfig.schemaName='lists';
	qconfig.filterArray=[LABKEY.Filter.create('crfRef',getCRFref())];
	qconfig.success=function(data){afterRegistration(configUpload,data);}
	LABKEY.Query.selectRows(qconfig);
	//waitForCompleteUpload(config);//

}

function afterRegistration(configUpload,data){
	print("afterRegistration: rows:"+data.rows.length);
	configUpload.registration=data;
	let registrationData=configUpload.registration;
	clearErr();
	if (registrationData.rows.length!=1){
		let msg="ERROR: Found "+registrationData.rows.length;
		msg+=" registration entries for crfrefid "+getCRFref();
		print(msg);
		configUpload.afterId(configUpload);
		return;
	}
	print('registration participant field: '+config.registrationParticipantIdField);
	configUpload.participantId=
		registrationData.rows[0][config.registrationParticipantIdField];
	//could be a lookup field
	let fields=registrationData.metaData.fields;
	let field="NONE";
	for (f in fields){
		if (fields[f]["name"]==config.registrationParticipantIdField)
			field=fields[f];
	}
	if ("lookup" in field){
		let pid=configUpload.participantId;
		print("Using lookup for participantId: "+pid);
		let lookup=field["lookup"];
		print("Lookup: ["+lookup.schemaName+','+lookup.queryName+']');
		let qconfig=new Object();
		qconfig.containerPath=config.containerPath;
		qconfig.schemaName=lookup.schemaName;
		qconfig.queryName=lookup.queryName;
		qconfig.filterArray=
			[LABKEY.Filter.create(lookup.keyColumn,pid)];
		qconfig.success=function(data){
			afterRegistrationLookup(configUpload,data,lookup.displayColumn)};
		LABKEY.Query.selectRows(qconfig);
	}
	else{
		//afterParticipantId(configUpload);
		configUpload.afterId(configUpload);
	}
}

function afterRegistrationLookup(configUpload,data,displayColumn){
	print("afterRegistrationLookup");
	let entry=data.rows[0];
	configUpload.participantId=entry[displayColumn];
	print('Setting to '+configUpload.participantId);
	configUpload.afterId(configUpload);
	//afterParticipantId(configUpload);
}


function afterParticipantId(configUpload){
	print("Setting participantId to "+configUpload.participantId);
	//another select rows to update all queries from setup
	//just use registration for test
	let qconfig=new Object();
	qconfig.schemaName='lists';
	//qconfig.queryName=config.setupQueryName;
	qconfig.queryName="FormSetup";
	qconfig.filterArray=[LABKEY.Filter.create("formName",config.formId)];
	qconfig.success=function(data){afterSetup(configUpload,data);}
	LABKEY.Query.selectRows(qconfig);
}

function afterSetup(configUpload,data){

	configUpload.queries=new Array();

	for (let i=0;i<data.rows.length;i++){
		let entry=data.rows[i];
		//skip reviews
		if (entry.showFlag=="REVIEW") continue;
		//use lookup table to convert from id to name
		let queryName=config.queryMap[entry.queryName];
		configUpload.queries.push({queryName:queryName,queryStatus:"QUEUED"});
		if (entry.showQuery=="NONE")
			continue
		configUpload.queries.push({queryName:entry.showQuery,queryStatus:"QUEUED"});
	}
	//add reviews
	configUpload.queries.push({queryName:"reviewComments",queryStatus:"QUEUED"});
	configUpload.queryId=0;
	copyToDataset(configUpload);

	//config.upload["start"]=true;
	//for (u in config.upload){
	//	if (u=="start") continue;
	//	if (u=="count") continue;
	//	copyToDataset(config,u,participantId);
	//}
	//
	//print("Database updated");
}



function copyToDataset(configUpload){

	if (configUpload.queryId==configUpload.queries.length) {
		updateFlag(3);//Approved
		return;
	}

	let queryName=configUpload.queries[configUpload.queryId].queryName;
	print("copyToDataset["+configUpload.queryId+"/"+configUpload.queries.length+"]: "+queryName);
	let qconfig=new Object();
	qconfig.queryName=queryName;
	qconfig.schemaName="lists";
	qconfig.filterArray=[LABKEY.Filter.create('crfRef',getCRFref())];
	qconfig.success=function(data){afterListData(configUpload,data)};
	LABKEY.Query.selectRows(qconfig);
}

function afterListData(configUpload,data){

	let queryName=configUpload.queries[configUpload.queryId].queryName;
	let msg="["+queryName+"/list]: "+data.rows.length+" entries";
	print(msg);
	configUpload.queries[configUpload.queryId].listData=data;

	let qconfig=new Object();
	qconfig.queryName=queryName;
	qconfig.schemaName="study";
	qconfig.filterArray=[LABKEY.Filter.create('crfRef',getCRFref())];
	qconfig.filterArray.push(LABKEY.Filter.create('ParticipantId',configUpload.participantId));
	qconfig.success=function(data){afterStudyData(configUpload,data)};
	LABKEY.Query.selectRows(qconfig);
}


function afterStudyData(configUpload,data){
	configUpload.queries[configUpload.queryId].studyData=data;

	let queryName=configUpload.queries[configUpload.queryId].queryName;
	let msg="["+queryName+"/study]: "+data.rows.length+" entries";
	print(msg);
	

	let listRows=configUpload.queries[configUpload.queryId].listData.rows;
	//skip uploading an empty set
	if (listRows.length==0){
		printErr("List "+queryName+" empty.");
		configUpload.queries[configUpload.queryId].queryStatus="DONE";
		configUpload.queryId+=1;
		copyToDataset(configUpload);
		return;
	}
	

	let studyRows=configUpload.queries[configUpload.queryId].studyData.rows;

	for (let i=0;i<studyRows.length;i++){
		let entry=studyRows[i];
		if (! (i<listRows.length) ) continue;
		let entryList=listRows[i];
		//keeps study only variables (ParticipantId, SequenceNum)
		for (let f in entryList) {
			entry[f]=entryList[f];
			print("Copying ["+f+"]: "+entry[f]+"/"+entryList[f]);
		}
	}
	if (studyRows.length>0) {
		let qconfig=new Object();
		qconfig.queryName=queryName;
		qconfig.schemaName="study";
		qconfig.rows=studyRows;
		qconfig.success=function(data){afterStudyUpload(configUpload,data);}
		LABKEY.Query.updateRows(qconfig)
	}
	else{
		let data=new Object();
		data.rows=new Array();
		afterStudyUpload(configUpload,data);
	}
}

function afterStudyUpload(configUpload,data){
	
	//let participantField=config.participantField;
	let participantField=config.formConfig.studyData["SubjectColumnName"];

	let dataObject=configUpload.queries[configUpload.queryId];
	let queryName=dataObject.queryName;
	printErr("Updated "+data.rows.length+" rows to "+queryName);
	
	let studyRows=dataObject.studyData.rows;
	let listRows=dataObject.listData.rows;
	
	let rows=new Array();
	//also updating existing rows, if they exist
	for (let i=studyRows.length;i<listRows.length;i++){
		let entry=listRows[i];
		//make sure you have the participantField right
		//
		entry[participantField]=configUpload.participantId;
		entry.crfRef=getCRFref();
		entry.SequenceNum=getCRFref();
		entry.SequenceNum=entry.SequenceNum % 1000000000;
		
		if (listRows.length>1){
			entry.SequenceNum+=i/100;
		}
		print( "Adding sequence number "+entry.SequenceNum);
		rows.push(entry);
	}
	if (rows.length>0){

		let qconfig=new Object();
		qconfig.queryName=queryName;
		qconfig.schemaName="study";
		qconfig.success=function(data){
			afterListUpload(configUpload,data)};
		qconfig.rows=rows;
		LABKEY.Query.insertRows(qconfig);
	}
	else{
		let data=new Object();
		data.rows=rows;
		afterListUpload(configUpload,data);
	}
			
}

function afterListUpload(configUpload,data){

	let queryName=configUpload.queries[configUpload.queryId].queryName;
	printErr("Inserted "+data.rows.length+" rows to "+queryName);
	configUpload.queries[configUpload.queryId].queryStatus="DONE";
	configUpload.queryId+=1;
	copyToDataset(configUpload);

}




//*************************update for further review *************************

function onUpdateForReview(){
	updateFlag(4);//Pending review
}

function updateFlag(flag){
	if (flag==4)
		print("Sent to further review");
	let qconfig=new Object();
	qconfig.schemaName='lists';
	qconfig.queryName='crfEntry';
	qconfig.success=function(data){setFlag(data,flag);}
	qconfig.filterArray=[LABKEY.Filter.create("entryId",getCRFref())];
	LABKEY.Query.selectRows(qconfig);
}

function setFlag(data,flag){
	let debug=true;
	if (flag==4) print("setFlagToReview");
	if (data.rows.length!=1){
		let msg="ERROR: Found "+data.rows.length;
		msg+=" entries for crfrefid "+getCRFref();
		print(msg);
		return;
	}
	let entry=data.rows[0];
	entry.FormStatus=flag;//Pending Review
	if (debug)
		print("Set form status to "+entry.FormStatus);
	
	let qconfig=new Object();
	qconfig.schemaName='lists';
	qconfig.queryName='crfEntry';
	qconfig.rows=[entry];
	qconfig.success=function(data){completeWithFlag(data,flag);}
	LABKEY.Query.updateRows(qconfig);
	
}

function completeWithFlag(data,flag){

	let debug=true;

	if (debug){
		if (flag==4) print("complete with review");
	}
	redirect();

	
	

}

//************************************************ submit *******************************************


function onSubmit(){
	let debug=true;
	hideErr();
	clearErr();
	printErr("onSubmit");

	//the idea of check form is to provide a methodology for form validation
	//it consists of two parts - a routine that initiates the check, and a 
	//polling watchdog that waits for its execution.
	//Non-linear approach follows the natural javascript pathway.
	checkForm();

	//watchdog with callback that gets executed when checkForm is done
	let cb=new Object();
	cb.success=finalValidation;
	cb.failure=function(config){printErr("waitForCheckForm failed")};
	waitForCheckForm(cb);
}


function finalValidation(){
	let debug=true;
	if (debug) print("validate");
	
	let completed=true;
	for (f in config.fields){
		let field=config.fields[f];
		if (field.status!="DONE") {
			printErr("Missing entry for "+field.title);
			completed=false;
		}
	}
	if (debug) print("valid: "+completed);

	if (completed){
		modifyCRFEntry();
	}
	else{
		let el=document.getElementById(config.submitReportId);
		el.innerHTML="Form invalid";
	}
}

function modifyCRFEntry(){
	printErr("Form valid");
	let c1=new Object();
	c1.schemaName='lists';
	c1.queryName='crfEntry';
	c1.filterArray=[LABKEY.Filter.create('entryId',getCRFref())];
	c1.success=changeCRFStatus;
	LABKEY.Query.selectRows(c1);
}

function changeCRFStatus(data){
	
	let entry=data.rows[0];
	entry.formStatus=2;//Submitted
	let el=document.getElementById(config.submitReportId);
	el.innerHTML="Submitting form";
	let c1=new Object();
	c1.schemaName=data.schemaName;
	c1.queryName=data.queryName;
	c1.containerPath=config.containerPath;
	c1.rows=[entry];
	//close window upon success
	c1.success=function(data){redirect()};
	LABKEY.Query.updateRows(c1);
}

function hideErr(){
	let el=config.document.getElementById("errorDiv");
	el.style.display="none";
}

function clearErr(){
	let el=config.document.getElementById("errorTxt");
	el.value="";
}

function showErr(){
	let el=config.document.getElementById("errorDiv");
	el.style.display="block";
}

function printErr(msg){
	showErr();
	el=config.document.getElementById("errorTxt");
	el.style.color="red";
	el.value+="\n"+msg;
}


//validation worker
function checkForm(){
	let debug=false;
	let crfRef=getCRFref()


	config.status="UNKNOWN";
	//fields are queries that are part of the form
	//this allows validation to be performed on all
	//queries that are part of the form
	for (f in config.fields){
		let field=config.fields[f];
		field.status="UNKNOWN";

		if (debug) 
			print("Setting status for "+f+" to "+ field.status);

		let selectRows=new Object();
		selectRows.containerPath=config.containerPath;
		selectRows.schemaName="lists";
		selectRows.queryName=f;
		//select only entry related to present form
		selectRows.filterArray=[LABKEY.Filter.create('crfRef',crfRef)];
		selectRows.success=checkData;
		selectRows.failure=function(errorObj){print("checkData failed.")};
		LABKEY.Query.selectRows(selectRows);
	}
}

function waitForCheckForm(cb){
	//watchdog - a timeout function
	//if control reaches the end of the function, it gets re-executed after the timeout
	//the body provides two alternative routes that end with return, 
	//one for failure (if timeout gets executed too often)
	//one for success, which looks at the config object, which is in parallel
	//modified by the checkForm and as a daughter process, checkData functions
	
	
	let debug=true;
	//initalize counter
	if (!("i" in config)) config.i=0;
	
	//report execution depth
	if (debug) print("["+config.i+"] checkForm status "+config.status);
	
	//failure route
	if (config.i>100) {
		if (debug) print("executing failure");	
		cb.failure(config);
		return;
	}

	//success route; count on other functions to modify config.status
	//this is very non-obviuos for linear programing, but
	//checkData and waitForCheckForm share the same memory space
	if (config.status=="DONE") {
		if (debug) print("executing success");	
		cb.success(config);
		if (debug) print("success executed");	
		return;
	}

	//this is the repeat route, neither pathway was indicated, stay in loop
	config.i+=1;
	setTimeout(function(){waitForCheckForm(cb);},1000);
}

function checkData(data){
	//insulated worker. Data corresponds to entry of a particular query
	let debug=false;
	if (debug) print("checkData ");
	let field=config.fields[data.queryName];
	field.status="NONE";
	if (debug) print("Setting status for "+data.queryName+" to "+field.status);

	//this is the only test implemented - we should have at least one row in each of the queries
	//we could also have a more targeted functions, but their form escapes me at the moment
	if (data.rows.length>0)
		field.status="DONE";
		
	if (debug)
		print("checkData set status for "+data.queryName+" to "+field.status);
	

	//here we generate the flag/bell for the watchdog
	for (f in config.fields){
		let subField=config.fields[f];
		if (debug) 
			print("checkData status["+f+"]: "+subField.status);	
		//UNKNOW means we haven't visited it yet
		if (subField.status=="UNKNOWN") {
			if (debug) print("\t Status for "+f+" not set ["+ subField.status+"]");
			//we opt out - clearly, unchecked fields are still present
			return;
		}
		
	}
	//since we didn't exit for any field, we are done, and can set watchdog flag
	config.status="DONE";
}


//**************************************************
//
function onRemoveCRF(){
	let debug=true;

	if (debug){
		print("Removing CRF");
	}

	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName="lists";
	selectRows.queryName="inputLists";
	selectRows.success=afterInputLists;
	LABKEY.Query.selectRows(selectRows);
}

function afterInputLists(data){
	let debug=true;
	if (debug)
		print("After input lists");
	config.inputLists=data;
	config.inputListsIterator=0;

	removeCRFLoop();
}

function removeCRFLoop(){
	let debug=true;

	let i=config.inputListsIterator;
	
	if (debug)
		print("removeCRFLoop ["+i+"/"+config.inputLists.rows.length+"]");

	if (i>config.inputLists.rows.length){
		if (0) return;
		redirect();
	}
	let queryName="crfEntry";
	let idVar="entryId";

	
	if (i<config.inputLists.rows.length){
		queryName=config.inputLists.rows[i].queryName;
		idVar="crfRef";
	}
	if (debug)
		print("["+i+"/"+config.inputLists.rows.length+"] "+queryName+"/"+idVar);

	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName="lists";
	selectRows.queryName=queryName;
	selectRows.filterArray=[LABKEY.Filter.create(idVar,getCRFref())];
	selectRows.success=removeListCRF;
	selectRows.failure=skipListCRF;
	LABKEY.Query.selectRows(selectRows);
}

function removeListCRF(data){
	let debug=true;

	if (debug)
		print(data.queryName+": "+data.rows.length);

	config.inputListsIterator+=1;
	
	if (data.rows.length==0){
		removeCRFLoop();
		return;
	}

	let deleteRows=new Object();
	deleteRows.containerPath=config.containerPath;
	deleteRows.schemaName=data.schemaName;
	deleteRows.queryName=data.queryName;
	deleteRows.success=function(data){removeCRFLoop()};
	deleteRows.rows=data.rows;
	LABKEY.Query.deleteRows(deleteRows);
	
}

function skipListCRF(errorInfo){
	let debug=true;

	if (debug)
		print("Error in removeCRF: "+errorInfo.exception);

	config.inputListsIterator+=1;
	
	removeCRFLoop();
	
}



function redirect(){
	let formUrl="begin";
	let params=new Object();
	params.name=formUrl;
	params.pageId="CRF";

	let containerPath= config.containerPath;
        
	// This changes the page after building the URL. 
	//Note that the wiki page destination name is set in params.
        
	var homeURL = LABKEY.ActionURL.buildURL("project", formUrl , containerPath, params);
        print("Redirecting to "+homeURL);
		 
	window.location = homeURL;

	

}

config.blob;
config.blobInterval;

function checkBlob(){
	print("Blob: "+config.blob);
	if (blob) {
		clearInterval(config.blobInterval);
		config.a.href = config.window.URL.createObjectURL(config.blob);
		print("HREF: "+config.a.href);
		config.a.download = 'test.pdf';
		config.a.click();
		config.window.URL.revokeObjectURL(config.a.href);
	}
	config.count=config.count+1;
	print("Eval: "+config.count);
	if (config.count>100){
		clearInterval(config.blobInterval);
	}

}

function printForm(){

	let doPrint=false;
	
	//let doc=new PDFDocument();
	//doc.fontSize(25).text("Some text with standard font Andrej!", 100, 100);
	//doc.end();
	//let stream = doc.pipe(blobStream()).on("finish",function(){
	//		blob=stream.toBlob("application/pdf");});
	
	print("BLob: "+config.blob);
	config.a = config.document.createElement("a");
	config.document.body.appendChild(config.a);
	config.a.innerHTML="Download PDF";
	config.a.style = "display: none";
	config.count=0;
	lobInterval=setInterval(checkBlob,1000);

	//pick data from crfForm list
        print("Printing form");

	for (let i=0;i<config.formConfig.formSetup.rows.length;i++){
		let entry=config.formConfig.formSetup.rows[i];
		let qName=config.formConfig.queryMap[entry['queryName']];
		let selectRows=new Object();
		print('Adding data for '+qName);
		selectRows.containerPath=config.containerPath;
		selectRows.schemaName='lists';
		selectRows.queryName=qName;
		selectRows.filterArray=[LABKEY.Filter.create('crfRef',config.formConfig.crfEntry['entryId'])];
		selectRows.success=collectFormData;
		LABKEY.Query.selectRows(selectRows);
		//deal with additional data
	}
	
}

function collectFormData(data){
	config.formConfig.fields[data.queryName].data=data;
	for (f in config.formConfig.fields){
		let field=config.formConfig.fields[f];
		if ("data" in field) continue;
		return;
	}
	print("All done");
	formatFormData();
}

function formatFormData(){
	for (queryName in config.formConfig.fields){
		formatDataset(queryName);
	}
}

function formatDataset(queryName){
	let data=config.formConfig.fields[queryName].data;
	let fields=data.metaData.fields;
	for (let i=0;i<data.rows.length;i++){
		for (f in fields){
			let field=fields[f];
			if (field.hidden) continue;
			let vName=field.name;
			let vType=field.type;
			print('['+vName+'/'+vType+']: '+data.rows[i][vName]);
		}
	}

}




function generateMasterForm(){


	generateDebugSection();
	setFormConfig();
}

function populateBasicData(config){
	
	config.document.getElementById('eudraCTNumber').innerHTML=
		config.formConfig.crfEntry.EudraCTNumber;
	config.document.getElementById('studyCoordinator').innerHTML=
		config.formConfig.crfEntry.StudyCoordinator;
	config.document.getElementById('studySponsor').innerHTML=
		config.formConfig.crfEntry.StudySponsor;
	config.document.getElementById('siteName').innerHTML=
		config.formConfig.site['siteName'];
	config.document.getElementById('sitePhone').innerHTML=
		config.formConfig.site['sitePhone'];
	config.document.getElementById('investigatorName').innerHTML=
		config.formConfig.user['DisplayName'];
}

function afterConfig(){

	let debug=true;

	if (debug)
		print("generateMasterForm");	
	
	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName='lists';
	selectRows.queryName='crfEntry';
	selectRows.filterArray=[LABKEY.Filter.create('entryId',getCRFref())];
	
	let formConfig=new Object();
	//selectRows.success=function(data){populateBasicData(config,data)};
	selectRows.success=function(data){afterCrf(formConfig,data)};
	LABKEY.Query.selectRows(selectRows);
}

//requires populateBasicData
function afterCrf(formConfig,data){
	formConfig.crfEntry=data.rows[0];
	//schedule basic data for later
	populateBasicData(config);

	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName='lists';
	selectRows.queryName='FormStatus';
	selectRows.filterArray=[];
	
	selectRows.success=function(data){afterFormStatus(formConfig,data)};
	LABKEY.Query.selectRows(selectRows);	


	//use crfEntry['FormStatus'] to determine what configuration to display
	//reviewMode equivalence table:
	//
	//FormStatus	reviewMode
	//In Progress	undefined/EDIT
	//Review Pending undefined/EDIT
	//Submitted	REVIEW
	//Approved	APPROVED
	
	//two level indirect - 
	//
	//1. learn of the FormStatus options by reading in the FormStatus list
	//
	//2. Load the crfEntry for this crfId 
}
	

	
function afterFormStatus(formConfig, data){
	print("afterFormStatus: ");
	formConfig.formStatusData=data;
	
	let rows=formConfig.formStatusData.rows;

	for (let i=0; i<rows.length; i++){
		let key=rows[i].Key;
		if (formConfig.crfEntry["FormStatus"]!=key)
			continue;
		formConfig.formStatus=rows[i].formStatus;
		break;
	}

	print("Generating buttons for formStatus \""+
			formConfig.formStatus+"\"");
	
	let done="FALSE";
	if (formConfig.formStatus=="Submitted"){
		generateButton("submitDiv","Complete submission",
			"Upload to database",onDatabaseUpload);
		generateButton("submitDiv","Review submission",
			"Ask for further review",onUpdateForReview);
		generateButton("submitDiv","Remove submission",
			"Remove CRF form",onRemoveCRF);
		done="TRUE";
	}
	if (formConfig.formStatus=="Approved"){
		generateButton("submitDiv","Review submission",
			"Restore form for further review",onUpdateForReview);
		done="TRUE";
	}
	if (done=="FALSE"){
		generateButton("submitDiv","Complete submission",
			"Submit",onSubmit);
		generateButton("submitDiv","Remove submission",
			"Remove CRF form",onRemoveCRF);
	
	}

	generateButton("submitDiv","Done","Exit",redirect);
	print('Here');


	//schedule actual forms
	config.fields=new Object();	
	config.queryMap=new Object();

	//data and layout of actual forms
	//filled in generateTable
	formConfig.entries=new Object();
	formConfig.dataFields=new Object();

	let configSelectRows=new Object();
	configSelectRows.containerPath=config.containerPath;
	configSelectRows.schemaName='lists';
	configSelectRows.queryName=config.setupQueryName;
	//this is new
	configSelectRows.queryName="FormSetup";
	configSelectRows.filterArray=[
		LABKEY.Filter.create("formName",config.formId)];

	print('select rows into afterFormConfig id: '+config.formId);
	configSelectRows.success=function(data){
		afterFormConfig(formConfig,data);};
	configSelectRows.failure=onFailure;
	//function(errorTxt){print("generateForm fail" + errorTxt)};
	LABKEY.Query.selectRows(configSelectRows);

}

//entry point from generateMasterForm

function setFormConfig(){

	//generateDebugSection(config);

	let debug=true;

	if (debug)
		print("generateMasterForm1");	
	
	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName='lists';
	selectRows.queryName='crfEntry';
	selectRows.filterArray=[LABKEY.Filter.create('entryId',getCRFref())];
	config.formConfig=new Object();
	//store form related data to this object
	selectRows.success=afterCRFEntry;
	LABKEY.Query.selectRows(selectRows);
}

function afterCRFEntry(data){
	config.formConfig.crfEntry=data.rows[0];
	print("Setting crfEntry (x) to "+config.formConfig.crfEntry["entryId"]);

	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName='lists';
	selectRows.queryName='site';
	selectRows.filterArray=	[
		LABKEY.Filter.create('siteNumber',config.formConfig.crfEntry.Site)];
	selectRows.success=afterSite;
	LABKEY.Query.selectRows(selectRows);

}

function afterSite(data){
	print("afterSite");
	config.formConfig.site=data.rows[0];
	print("Setting site name to "+
			config.formConfig.site["siteName"]
			+" phone: "+config.formConfig.site["sitePhone"]);

	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName='core';
	selectRows.queryName='Users';
	selectRows.filterArray=[
		LABKEY.Filter.create('siteNumber',
				config.formConfig.crfEntry.UserId)];
	selectRows.success=afterUser;
	LABKEY.Query.selectRows(selectRows);
}

function afterUser(data){
	config.formConfig.user=data.rows[0];
	print("Setting user to "+config.formConfig.user["DisplayName"]);

	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName='study';
	selectRows.queryName='Study';
	selectRows.columns="SubjectColumnName";
	selectRows.success=afterStudy;
	LABKEY.Query.selectRows(selectRows);

}

function afterStudy(data){
	config.formConfig.studyData=data.rows[0];
	print("XSetting participantField to "+config.formConfig.studyData["SubjectColumnName"]);

	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName='lists';
	selectRows.queryName='FormSetup';
	selectRows.filterArray=[LABKEY.Filter.create('formName',config.formId)];
	selectRows.success=afterFormSetup;
	LABKEY.Query.selectRows(selectRows);

}


function afterFormSetup(data){
	config.formConfig.formSetup=data;
	print("Number of datasets for form ["+config.formId+"]: "+
			config.formConfig.formSetup.rows.length);

	let fields=config.formConfig.formSetup.metaData.fields;
	let formQueryName='queryName';
	let field="NONE";
	for (f in fields){
		if (fields[f]['name']!=formQueryName) continue;
		field=fields[f];
		break;
	}
	let lookup=field.lookup;

	print("Getting dataset names from :"+lookup.queryName);
	let selectRows=new Object();
	selectRows.containerPath=config.containerPath;
	selectRows.schemaName=lookup.schemaName;
	selectRows.queryName=lookup.queryName;
	selectRows.success=afterFormDatasets;
	LABKEY.Query.selectRows(selectRows);

}

function afterFormDatasets(data){
	config.formConfig.formDatasets=data;
	config.formConfig.fields=new Object();
	config.formConfig.queryMap=new Object();
	for (let i=0;i<config.formConfig.formSetup.rows.length;i++){
		let entry=config.formConfig.formSetup.rows[i];
		let queryId=entry['queryName'];
		for (let j=0;j<config.formConfig.formDatasets.rows.length;j++){
			if (queryId!=config.formConfig.formDatasets.rows[j]['Key']) continue;
			let qName=config.formConfig.formDatasets.rows[j]['queryName'];
			config.formConfig.fields[qName]=new Object();
			config.formConfig.queryMap[queryId]=qName;
			let field=config.formConfig.fields[qName];
			field.title=entry['title'];
			field.queryId=queryId;
			//print("     "+config.formConfig.formDatasets.rows[j]['queryName']);
			break;
		}
	}
	print("List of datasets in form : ");
	for (f in config.formConfig.fields){
		let field=config.formConfig.fields[f];
		print("\t"+f+" ID: "+field.queryId+' title '+field.title);
	}
	afterConfig();

}

//function loadFile(config){
//
//	let file=config.fb.files[0];
//	print(config.config,'Y: '+file.name);
//
	//will be part of config
//	let server='https://merlin.fmf.uni-lj.si/labkey/_webdav';
//	let project='Test';
//        let path='@files';
//        let url=server+'/'+project+'/'+path+'/'+file.name;
//	let connConfig=new Object();
//	connConfig.disableCaching=true;
//	connConfig.method='PUT';
//	connConfig.url=url;¸
//        let conn = new Ext4.data.Connection(connConfig);
//	print(config.config,'YY: '+url);

//	let request=new Object();
//	request.headers=new Object();
//        headers['Content-Type']='application/octet-stream';
//        headers['X-Requested-With']='XMLHttpRequest';
	//add file as rawData element
//	request.rawData=file;
	//add success call-back
//	request.success=function(){print(config.config,'YYY');}
//	conn.request(request);
//	print(config.config,'YYYY');
//
//}

function addFileUpload(config, divName){
	let el=config.document.getElementById(divName);
	let tab=config.document.createElement('table');
	let row=tab.insertRow(0);
	let c1=row.insertCell(0);
	let fb=config.document.createElement('input');
	fb.setAttribute("type", "file");
	fb.id=divName+'_fileSelect';
	c1.appendChild(fb);
	let c2=row.insertCell(1);
	let sb=config.document.createElement('input');
	sb.setAttribute("type", "button");
	sb.id=divName+'_submitFiles';
	sb.value='Submit';
	el.appendChild(tab);

	let loadFileConfig=new Object();
	loadFileConfig.fb=fb;
	loadFileConfig.config=config;
//	sb.addEventListener('click', function(){loadFile(loadFileConfig);});
	print('X: '+sb);
}


